/* This header file is shared by client & server. They really have
 * something to share...
 * */

/* Client/server protocol is as follows:
   Send INIT_PASSWD
   Send 64-bit cliserv_magic
   Send 64-bit size of exported device
   Send 128 bytes of zeros (reserved for future use)
 */

#include "config.h"

#if SIZEOF_UNSIGNED_SHORT_INT==4
  typedef unsigned short u32;
#elif SIZEOF_UNSIGNED_INT==4
  typedef unsigned int u32;
#elif SIZEOF_UNSIGNED_LONG_INT==4
  typedef unsigned long u32;
#else
#error I need at least some 32-bit type
#endif


#if SIZEOF_UNSIGNED_INT==8
  typedef unsigned int u64;
#elif SIZEOF_UNSIGNED_LONG_INT==8
  typedef unsigned long u64;
#elif SIZEOF_UNSIGNED_LONG_LONG_INT==8
  typedef unsigned long long u64;
#else
#error I need at least some 64-bit unsigned type
#endif

#if SIZEOF_INT==8
  typedef int s64;
#elif SIZEOF_LONG_INT==8
  typedef long s64;
#elif SIZEOF_LONG_LONG_INT==8
  typedef long long s64;
#else
#error I need at least some 64-bit signed type
#endif


/*#include <asm/semaphore.h>*/
#include <linux/nbd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <asm/socket.h>

u64 cliserv_magic = 0x00420281861253LL;
#define INIT_PASSWD "NBDMAGIC"

#define INFO(a) do { } while(0)

void setmysockopt(int sock)
{
	int size;
#if 0
        struct timeval timeout = { tv_sec: 60, tv_usec: 0 };
#endif
#if 1
        struct linger lin = { l_onoff: 0, l_linger: 0 };
#endif

#if 0
	size = 1;
	if (setsockopt(sock, SOL_SOCKET, SO_SNDBUF, &size, sizeof(int)) < 0)
		 INFO("(no sockopt/1: %m)");
#endif
	size = 1;
	if (setsockopt(sock, SOL_TCP, TCP_NODELAY, &size, sizeof(int)) < 0)
		 INFO("(no sockopt/2: %m)");
#if 0
	//size = 1024;
	size = 4096;
	if (setsockopt(sock, SOL_TCP, TCP_MAXSEG, &size, sizeof(int)) < 0)
		 INFO("(no sockopt/3: %m)");
#endif
#if 1
	size = 1;
	if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &size, sizeof(int)) < 0)
		 INFO("(no sockopt/4: %m)");
#endif
#if 1
	size = 1;
	if (setsockopt(sock, SOL_SOCKET, SO_KEEPALIVE, &size, sizeof(int)) < 0)
		 INFO("(no sockopt/5: %m)");
#endif
#if 0
	if (setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, &timeout, sizeof(timeout)) < 0)
		 INFO("(no sockopt/6: %m)");
#endif
#if 0
	if (setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, &timeout, sizeof(timeout)) < 0)
		 INFO("(no sockopt/7: %m)");
#endif
#if 1
        if (setsockopt(sock, SOL_SOCKET, SO_LINGER, &lin, sizeof(lin)) < 0)
                 INFO("(no sockopt/8: %m)");
#endif

}

#define MSG(s...) { \
          /* syslog(LOG_DAEMON|LOG_INFO|LOG_CONS|LOG_PERROR, MY_NAME ": * " s) ; */ \
	  fprintf(stderr, MY_NAME ": " s); \
   }
#define perr(s...) PERR(s)
/* syslog logging client side too seems to be better! */
#define PERR(s...) { \
          syslog(LOG_DAEMON|LOG_INFO|LOG_CONS|LOG_PERROR, MY_NAME ": " s); \
	  fprintf(stderr, MY_NAME ": " s); \
	}

#define err(s) { perr(s); exit(1); }

void logging(void)
{
#ifdef ISSERVER
	openlog(MY_NAME, LOG_PID, LOG_DAEMON);
#endif
	setvbuf(stdout, NULL, _IONBF, 0);
	setvbuf(stderr, NULL, _IONBF, 0);
}

#ifdef WORDS_BIGENDIAN
u64 ntohll(u64 a)
{
	return a;
}
#else
u64 ntohll(u64 a)
{
	u32 lo = a & 0xffffffff;
	u32 hi = a >> 32U ;
	lo = ntohl(lo);
	hi = ntohl(hi);
	return ((u64) lo) << 32U | hi;
}
#endif
#define htonll ntohll
